/*  Copyright (C) 2015 Zoltán Nagy
 *  Created by Zoltán Nagy on 1/24/15.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/*   std includes   */

/*   project headers  */
#include "fs-error.h"


namespace duct {
  namespace filesystem {
    
    const path filesystem_error::_M_empty_path = path();
    
    const char* filesystem_error::what() const noexcept
    {
      if(!_M_ptr) return std::system_error::what();
      
      try
      {
        if(_M_ptr->what.empty())
        {
          _M_ptr->what = std::system_error::what();
          if(!_M_ptr->path1.empty()) {
            _M_ptr->what += ": \"";
            _M_ptr->what += _M_ptr->path1.string();
            _M_ptr->what += "\"";
          }
          
          if(!_M_ptr->path2.empty()) {
            _M_ptr->what += ", \"";
            _M_ptr->what += _M_ptr->path2.string();
            _M_ptr->what += "\"";
          }
        }
        
        return _M_ptr->what.c_str();
      } catch (...) {
        return std::system_error::what();
      }
    }

  }
}

