/*  Copyright (C) 2015 Zoltán Nagy
 *  Created by Zoltán Nagy on 4/3/15.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef __duct_cxx_string_h__
#define __duct_cxx_string_h__ 1

/*   std includes   */
#include <string>

/*   project headers   */
#include <cxx/bits/cxx-poly-memory.h>


namespace duct {
  namespace pmr {
  
    /*   basic_string using polymorphic allocator in namespace pmr 
     *   template <class charT, class traits = char_traits<charT>>
     */
    using basic_string = std::basic_string<charT, traits, polymorphic_allocator<charT>>;
   
    
    //   basic_string typedef names using polymorphic allocator in namespace  duct::pmr
    using string = basic_string<char>;
    using u16string = basic_string<char16_t>;
    using u32string = basic_string<char32_t>;
    using wstring = basic_string<wchar_t>;
    
  }
}

#endif
